%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
assert_isequal(nargin('audiometadata'), -1);
assert_isequal(nargout('audiometadata'), 1);
%=============================================================================
wav_file = [modulepath('audio'), '/tests/6_Channel_ID.wav'];
info = audiometadata(wav_file);
assert_isequal(size(info), [1 1]);
assert_istrue(isempty(fieldnames(info)));
assert_istrue(iscell(fieldnames(info)));
%=============================================================================
flac_file = [modulepath('audio'), '/tests/handel.flac'];
info = audiometadata(flac_file);
assert_isequal(info.ALBUM, 'album name')
assert_isequal(info.DESCRIPTION, 'some comments')
assert_isequal(info.GENRE, 'music')
assert_isequal(info.TITLE, 'handel (title)')
assert_isequal(info.TRACKNUMBER, '3')
%=============================================================================
wav_file = [modulepath('audio'), '/tests/DynoA3.wav'];
info = audiometadata(wav_file);
assert_isequal(info.ALBUM, 'album test');
assert_isequal(info.ALBUMARTIST, 'artist 3 3');
assert_isequal(info.ARTIST, 'artist test');
assert_isequal(info.COMMENT, 'test comments');
assert_isequal(info.COMPOSER, 'none');
assert_isequal(info.DATE, '1900');
assert_isequal(info.DISCNUMBER, '44');
assert_isequal(info.GENRE, 'Acoustic');
assert_isequal(info.TITLE, 'title test');
assert_isequal(info.TRACKNUMBER, '42');
%=============================================================================
ogg_file = [modulepath('audio'), '/examples/drums.ogg'];
info = audiometadata(ogg_file);
assert_isequal(info.ENCODER, 'Lavc58.9.100 libvorbis');
assert_isequal(info.LANGUAGE, 'fra');
assert_isequal(info.LANGUAGE_2_LETTER, '-FR');
assert_isequal(info.ORGANIZATION, 'Parlophone');
assert_isequal(info.RELEASE_TYPE, 'Normal release');
assert_isequal(info.RIP_DATE, '2014-10-08');
assert_isequal(info.RIPPING_TOOL, 'EAC');
assert_isequal(info.SOURCE, 'CD (LP)');
assert_isequal(info.TITLE, 'drums');
%=============================================================================
