//=============================================================================
// Copyright (c) 2016-present Allan CORNET (Nelson)
//=============================================================================
// This file is part of the Nelson.
//=============================================================================
// LICENCE_BLOCK_BEGIN
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// Alternatively, you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this program. If not, see <http://www.gnu.org/licenses/>.
// LICENCE_BLOCK_END
//=============================================================================
#include "zipBuiltin.hpp"
#include "Error.hpp"
#include "Zip.hpp"
#include "ToCellString.hpp"
//=============================================================================
using namespace Nelson;
//=============================================================================
ArrayOfVector
Nelson::FileArchiverGateway::zipBuiltin(int nLhs, const ArrayOfVector& argIn)
{
    ArrayOfVector retval;
    nargincheck(argIn, 1, 3);
    nargoutcheck(nLhs, 0, 1);
    std::wstring rootPath = L".";
    std::wstring zipFilename = argIn[0].getContentAsWideString();
    wstringVector names = argIn[1].getContentAsWideStringVector();
    wstringVector filenames;
    if (argIn.size() > 2) {
        rootPath = argIn[2].getContentAsWideString();
        if (rootPath.empty()) {
            rootPath = L".";
        }
    }
    Zip(zipFilename, names, rootPath, filenames);
    if (nLhs > 0) {
        retval << ToCellStringAsRow(filenames);
    }
    return retval;
}
//=============================================================================
