%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
assert_isequal(nargin('profsave'), 2);
assert_isequal(nargout('profsave'), 0);
%=============================================================================
profile('on')
run('script_to_profile.m');
profile('off')
destdir = [tempdir(), 'profsave_test'];
if isdir(destdir)
  rmdir(destdir, 's');
end
mkdir(destdir);
profsave(profile('info'), destdir)
assert_istrue(isfile([destdir, '/file0.html']));
assert_istrue(isfile([destdir, '/file1.html']));
assert_istrue(isfile([destdir, '/index.html']));
assert_istrue(isfile([destdir, '/highlight.pack.js']));
assert_istrue(isfile([destdir, '/mono-blue.css']));
assert_istrue(isfile([destdir, '/sort.js']));
if isdir(destdir)
  rmdir(destdir, 's');
end
%=============================================================================
