%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
function doc(varargin)
  % replaces standard 'doc' function to open help in web browser
  url_help = 'https://nelson-9.gitbook.io/nelson/en/';
  if nargin() > 1
    error(_('Wrong number of input arguments.'));
  end
  if nargin() == 1
    name = varargin{1};
    if ~ischar(name)
      error(_('Wrong type for argument #1: string expected.'));
    end
    module = which(name,'-module');
    if isempty(module)
      sioemit('help', [url_help , '?q=', name]);
    else
      if length(module) == 1
        sioemit('help', [url_help, module{1}, '/', name, '.html']);
      else
        sioemit('help', [url_help , '?q=', name]);
      end
    end
  else
   sioemit('help', url_help);
  end
end
%=============================================================================
