%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
% http://slicot.org/objects/software/shared/doc/MB04MD.html
% [MAXRED_OUT, A_OUT, SCALE, INFO] = slicot_mb04md(MAXRED_IN, A_IN)
%=============================================================================
assert_isequal(nargin('slicot_mb04md'), 2);
assert_isequal(nargout('slicot_mb04md'), 4);
%=============================================================================
MAXRED_IN  = 0.0;
A_IN = [1.0   0.0   0.0   0.0;
300.0 400.0 500.0 600.0;
1.0   2.0   0.0   0.0;
1.0   1.0   1.0   1.0];
[MAXRED_OUT, A_OUT, SCALE, INFO] = slicot_mb04md(MAXRED_IN, A_IN);
%=============================================================================
MAXRED_OUT_REF = 1.3977;
assert_isapprox(MAXRED_OUT, MAXRED_OUT_REF, 1e-4);
%=============================================================================
A_OUT_REF = [ 1       0       0       0;
30     400      50      60;
1      20       0       0;
1      10       1       1];
assert_isequal(A_OUT, A_OUT_REF);
%=============================================================================
SCALE_REF = [1     10      1      1];
assert_isequal(SCALE, SCALE_REF);
%=============================================================================
INFO_REF = int32(0);
assert_isequal(INFO, INFO_REF);
%=============================================================================
