%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
[p, f, e] = fileparts(nfilename('fullpathext'));
generated_filename = [p, '/', 'generated.iss'];
fp = fopen(generated_filename, 'wt');
if fp ~= -1
  fprintf(fp, ['#define GENERATED_INFO', char(10)]);
  compiler = version('-compiler');
  vernumber = version('-number');
  if strcmp(compiler{3}, '64') == true
    fprintf(fp, ['#define NELSON_X64', char(10)]);
  end
  if strcmp(compiler{2}, 'debug') == true
    fprintf(fp, ['#define NELSON_DEBUG', char(10)]);
  end
  fprintf(fp, ['#define APPLICATION_VERSION "', int2str(vernumber(1)), '.', int2str(vernumber(2)), '.', int2str(vernumber(3)), '.', int2str(vernumber(4)), '"', char(10)]);
  currentdate = datevec(now);
  fprintf(fp, ['#define CURRENT_YEAR "', int2str(currentdate(1)), '"', char(10)]);
  fclose(fp);
end
%=============================================================================
